Skip to main content

QuickSelect - Medium

Problem : Given an unsorted array, find the kth smallest element.

The problem is called the Selection problem. It's been intensively studied and has a couple of very interesting algorithms that do the job. I'll be  describing an algorithm called QuickSelect. The algorithm derives its name from QuickSort. You will probably recognise that most of the code directly borrows from QuickSort. The only difference being there is a single recursive call rather than 2 in QuickSort.

The naive solution is obvious, simply sort the array `O(nlogn)` and return the kth element. Infact, you can partially sort it and use the Selection sort to get the solution in `O(nk)`

An interesting side effect of finding the kth smallest element is you end up finding the k smallest elements. This also effectively gives you (n - k) largest elements in the array as well. These elements are not in any particular order though.

The version I'm using uses a random pivot selection, this part of the algorithm usually decides how fast it will be. Ideally you should pick the median, but calculating median of an array is basically a selection problem itself! (where k = n/2)

So we usually use the cheap route and pick a random pivot. We use the `partition` function from `quickSort`to separate the array into 2 subarrays. The left one will contain all elements less than or equal to the pivot value. The right one will have elements greater than pivot.

At this point we check if the k lies within [0,pivotIndex] or [pivotIndex,n].
We then recurse in that direction, ignoring the other subarray , it doesn't interest us anymore since it won't have our solution.

import random
def partition(arr, l , r):
rnd = random.randint(l,r)
pivot = arr[rnd]
arr[r],arr[rnd] = arr[rnd],arr[r]
j = l
for i in xrange(l , r ):
if arr[i] < pivot:
arr[i],arr[j] = arr[j],arr[i]
j += 1
arr[j],arr[r] = arr[r],arr[j]
return j
def quick_select(arr,l,r,k):
if l < r :
index = partition(arr,l,r)
if index == k: return arr[k]
elif k < index:
return quick_select(arr, l , index - 1,k)
else:
return quick_select(arr, index + 1, r,k)
return arr[l]
view raw quick-select.py hosted with ❤ by GitHub


Complexity: O(nlogn) on average.

Theoretically, It is possible to do this in O(n). But the implementation hides huge constants and complexities which doesn't make it worth the effort.

Comments

Popular posts from this blog

Find Increasing Triplet Subsequence - Medium

Problem - Given an integer array A[1..n], find an instance of i,j,k where 0 < i < j < k <= n and A[i] < A[j] < A[k]. Let's start with the obvious solution, bruteforce every three element combination until we find a solution. Let's try to reduce this by searching left and right for each element, we search left for an element smaller than the current one, towards the right an element greater than the current one. When we find an element that has both such elements, we found the solution. The complexity of this solution is O(n^2). To reduce this even further, One can simply apply the longest increasing subsequence algorithm and break when we get an LIS of length 3. But the best algorithm that can find an LIS is O(nlogn) with O( n ) space . An O(nlogn) algorithm seems like an overkill! Can this be done in linear time? The Algorithm: We iterate over the array and keep track of two things. The minimum value iterated over (min) The minimum increa...

Dijkstra's algorithm - Part 1 - Tutorial

This will be a 3 Part series of posts where I will be implementing the Dijkstra's Shortest Path algorithm in Python. The three parts will be 1) Representing the Graph 2) Priority Queue 3) The Algorithm To represent a graph we'll be using an  Adjacency List . Another alternative is using an Adjacency Matrix, but for a sparse graph an Adjacency List is more efficient. Adjacency List An Adjacency List is usually represented as a HashTable (or an Array) where an entry at `u` contains a Linked List. The Linked List contains `v` and optionally another parameter `w`. Here `u` and `v` are node(or vertex) labels and `w` is the weight of the edge. By Traversing the linked list we obtain the immediate neighbours of `u`. Visually, it looks like this. For implementing this in Python, we'll be using the dict()  for the main HashTable. For the Linked List we can use a list of 2 sized tuples (v,w).  Sidenote: Instead of a list of tuples, you can use a dict(), ...

Find the Quadruplets - Hard

Problem - Given 4 arrays A,B,C,D. Find out if there exists an instance where A[i] + B[j] + C[k] + D[l] = 0 Like the Find the Triple problem, we're going to develop 4 algorithms to solve this. Starting with the naive O(n^4) solution. Then we proceed to eliminate the inner-most loop with a Binary Search, reducing the complexity to O(n^3 logn) Now, we replace the last 2 loops with the left-right traversal we did in the previous 3 posts. Now the complexity is O(n^3). Finally, we reduce the complexity to O(n^2 logn) at the cost of O(n^2) Space Complexity. We store every combination of A[i] + B[j] and store it in AB[]. Similarly we make CD[] out of C[i] + D[j]. So, AB = A x B CD = C x D We then sort AB and CD (which costs O(n^2 log(n^2)) ~ O(n^2 logn) ) and then run a left-right linear Algorithm on AB and CD. (Note : Their size is of the order O(n^2)) So the overall complexity is due to sorting the large array of size n^2. which is O(n^2 logn).